----------------------------------------------------------------------------
--
-- © Copyright CERN 2000-2019. All rigths reserved. This software is released under a CERN proprietary software licence.
-- Any permission to use it shall be granted in writing. Request shall be adressed to CERN through mail-KT@cern.ch
--
----------------------------------------------------------------------------

%parser Table_CooLexerIO
%decl CooLexerIO.hpp
%impl CooLexerIO_gen.cpp

-- BASIC TOKENS
%token EOL_SYMBOL "New line '\\n'"
%token COMMENTSTRING "Comment"
%token WORD "Word"
%token INTEGER "Integer number"
%token DECIMAL "Decimal number"

-- KEYWORDS
	%token NOM "%NOM"
	%token PERCENTAGE "%"
	-- Referential
		%token OLOC "#*OLOC"
		%token LEP "#*LEP"
		%token RS2K "#*RS2K"
		%token SPHE "#*SPHE"
	-- Coordinates
		%token X "X"
		%token Y "Y"
		%token Z "Z"
		%token H "H"
		%token N "N"
	-- Sigmas
		%token SX "SX"
		%token SY "SY"
		%token SZ "SZ"
	-- Displacements
		%token DX "DX"
		%token DY "DY"
		%token DZ "DZ"
		%token DH "DH"
	-- Covariance
		%token COVXY "COVXY"
		%token COVXZ "COVXZ"
		%token COVYZ "COVYZ"
	-- Ellipses
		%token DIRECTION "DIRECTION"
		%token LONGUEUR "LONGUEUR"
	-- Others
		%token ID "ID"
		%token DCUM "DCUM"
		%token OPTION "OPTION"
	-- Frames
		%token FRAME_NAME "%FRAME_NAME"
		%token FRAME_ID "FRAME_ID"
		%token TX "TX"
		%token TY "TY"
		%token TZ "TZ"
		%token RX "RX"
		%token RY "RY"
		%token RZ "RZ"
		%token SCL "SCL"
		%token _TX "(TX)"
		%token _TY "(TY)"
		%token _TZ "(TZ)"
		%token _RX "(RX)"
		%token _RY "(RY)"
		%token _RZ "(RZ)"
		%token _SCL "(SCL)"
	-- Shit
		%token HTOL "COORDONNÉES POINTS DE RÉFÉRENCE"

-- STARTING POINT
%start CooDocument

-- CooLexerIO.hpp

/:
/**
 * /!\ This file is automatically generated by QLALR from CooLexerIO.g.
 * /!\ Don't edit it!
 */

#ifndef COOLEXERIO_HPP
#define COOLEXERIO_HPP

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "PluginsGlobal.hpp"
#include "$header"

class SUGL_SHARED_EXPORT CooLexerIO : public LexerParser<$table>
{
	Q_OBJECT

public:
	CooLexerIO(QObject *parent = nullptr);
	virtual ~CooLexerIO() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		/** Comment / ignored part */
		Comment,
		/** not special stuff */
		Normal,
		/** Coordinate system */
		Referential,
		/** Name of a point */
		PointName,
		/** Coordinates of a point */
		PointCoordinate,
		/** Sigmas of a point */
		PointSigma,
		PointSigmaKeyword,
		/** Displacements of a point */
		PointDisplacement,
		/** Informations */
		PointInfo,
		/** Type of point (VXY...) */
		PointType,
		/** Frames */
		Frame,
		FrameID,
		FrameTranslation,
		FrameRotation
	};
	// implemented in CooLexerIO_impl.cpp
	virtual const char *language() const override { return "CooPoint"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in CooLexerIO_impl.cpp
	virtual const std::string &getMIMEType() const override;
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &list) override;
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &frame) override;
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &point) override;
	virtual std::string write(const ShareablePosition &position) override;
	
	// CooLexerIO
	/**
	 * The column line read by the lexer.
	 *
	 * This is used when the class is not used as a lexer, but as a serializer.
	 * In case you provide only one point, we can't know what are the columns. This header allows the
	 * serializer to know what is what.
	 */
	const QString &columnsHeader() const noexcept { return _columnsHeader; }
	void columnsHeader(QString header) noexcept { _columnsHeader = std::move(header); }

protected:
	// CooLexerIO
	/** Called each time we meet a point name */
	virtual void gotPointName([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point coordinate */
	virtual void gotPointCoordinate([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point sigma */
	virtual void gotPointSigma([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point displacement */
	virtual void gotPointDisplacement([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a point info (ID, DDCUM...) */
	virtual void gotPointInfo([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet other (OPTION, ...) */
	virtual void gotPointType([[maybe_unused]] QStringRef sym) {}
	/** Called each time we meet a frame name */
	virtual void gotFrameName([[maybe_unused]] QStringRef sym) {}

private:
	static constexpr int COLUMNDEF = 1;
	static constexpr int OUT1MODE = 2;
	static constexpr int HTOLMODE = 3;

private:
	// LexerParser
	// generated in in LGCInputLexerIO_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;

private:
	QString _columnsHeader;
	ShareablePointsList _curList;
	ShareableFrame *_curFrame = nullptr;
	ShareablePoint *_curPoint = nullptr;
};

#endif // COOLEXERIO_HPP
:/

-- CooLexerIO_gen.cpp

/.
/**
 * /!\ This file is automatically generated by QLALR from CooLexerIO.g.
 * /!\ Don't edit it!
 */

#include "CooLexerIO.hpp"

#include <QRegularExpression>

#include <ShareablePoints/ShareableExtraInfos.hpp>
#include <ShareablePoints/ShareableFrame.hpp>
#include <ShareablePoints/ShareableParams.hpp>
#include <ShareablePoints/ShareablePoint.hpp>
#include <ShareablePoints/ShareablePosition.hpp>

namespace
{
inline QString toTrimmedQString(const QStringRef &str)
{
	return str.trimmed().toString();
}
} // namespace

void CooLexerIO::consumeRule(int rule)
{
	switch(rule)
	{
./

----------------------------------------------------------- RULES

---- Definitions

EOL: EOL_SYMBOL
	| EOL EOL_SYMBOL;

Number: INTEGER
	| DECIMAL;

AlNum: WORD
	| Number;

CooRubbish: AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| CooRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./

---- Referential

CReferential: OLOC
/. case $rule_number: ./
	| LEP
/. case $rule_number: ./
	| RS2K
/. case $rule_number: ./
	| SPHE;
/.
	case $rule_number:
		addStyle(1, Styles::Comment);
		addStyle(sym(1).size() - 1, Styles::Referential);
		if (!_lexerMode)
			_curList.getParams().extraInfos["coordinateSystem"] = toByteArray(toTrimmedQString(sym(1).mid(1)), utf8()).constData();
		break;
./

---- Header

Hnom: NOM;
/.
	case $rule_number:
		addStyleSym(Styles::PointName, 1);
		_columnsHeader = _currentLine.trimmed().toString();
		break;
./

Hx: X;
/. case $rule_number: ./
Hy: Y;
/. case $rule_number: ./
Hz: Z;
/. case $rule_number: ./
Hn: N;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		break;
./
Hh: H;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		_curList.getParams().coordsys = ShareableParams::ECoordSys::k2DPlusH;
		break;
./

Hsx: SX;
/. case $rule_number: ./
Hsy: SY;
/. case $rule_number: ./
Hsz: SZ;
/.
	case $rule_number:
		addStyleSym(Styles::PointSigmaKeyword, 1);
		break;
./

Hdx: DX;
/. case $rule_number: ./
Hdy: DY;
/. case $rule_number: ./
Hdz: DZ;
/. case $rule_number: ./
Hdh: DH;
/.
	case $rule_number:
		addStyleSym(Styles::PointDisplacement, 1);
		break;
./

Hid: ID;
/. case $rule_number: ./
Hdcum: DCUM;
/.
	case $rule_number:
		addStyleSym(Styles::PointInfo, 1);
		break;
./

Hoption: OPTION;
/.
	case $rule_number:
		addStyleSym(Styles::PointType, 1);
		break;
./

Hcovxy: COVXY;
/. case $rule_number: ./
Hcovxz: COVXZ;
/. case $rule_number: ./
Hcovyz: COVYZ;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./

Hdirectionx: DIRECTION X;
/. case $rule_number: ./
Hdirectiony: DIRECTION Y;
/. case $rule_number: ./
Hdirectionz: DIRECTION Z;
/. case $rule_number: ./
Hlongueurx: LONGUEUR X;
/. case $rule_number: ./
Hlongueury: LONGUEUR Y;
/. case $rule_number: ./
Hlongueurz: LONGUEUR Z;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;
./

Hunits: HunitsHeader EOL PERCENTAGE;
/. case $rule_number: ./
HunitsHeader: PERCENTAGE CooRubbish;
/.
	case $rule_number:
		_columnsHeader += '\n' + _currentLine.trimmed().toString();
		break;
./

Htol: HTOL CooRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		_contexts.push_back(CooLexerIO::HTOLMODE);
		break;
./

---- Frame header

Frame: FRAME_NAME;
/.
	case $rule_number:
		addStyleSym(Styles::PointName, 1);
		_columnsHeader = _currentLine.trimmed().toString();
		break;
./
FrameId: FRAME_ID;
/.
	case $rule_number:
		addStyleSym(Styles::FrameID, 1);
		break;
./

Tx: TX;
/. case $rule_number: ./
Ty: TY;
/. case $rule_number: ./
Tz: TZ;
/. case $rule_number: ./
_Tx: _TX;
/. case $rule_number: ./
_Ty: _TY;
/. case $rule_number: ./
_Tz: _TZ;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		break;
./

Rx: RX;
/. case $rule_number: ./
Ry: RY;
/. case $rule_number: ./
Rz: RZ;
/. case $rule_number: ./
_Rx: _RX;
/. case $rule_number: ./
_Ry: _RY;
/. case $rule_number: ./
_Rz: _RZ;
/.
	case $rule_number:
		addStyleSym(Styles::PointDisplacement, 1);
		break;
./

Scl: SCL;
/. case $rule_number: ./
_Scl: _SCL;
/.
	case $rule_number:
		addStyleSym(Styles::PointType, 1);
		break;
./
 ---- Frame definition

FRAMENAME: WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Frame, 1);
		gotFrameName(sym(1));
		break;
./

FRAMEID: WORD;
/.
	case $rule_number:
		addStyleSym(Styles::FrameID, 1);
		break;
./

FTX: DECIMAL;
/. case $rule_number: ./
FTY: DECIMAL;
/. case $rule_number: ./
FTZ: DECIMAL;
/. case $rule_number: ./
_FTX: INTEGER;
/. case $rule_number: ./
_FTY: INTEGER;
/. case $rule_number: ./
_FTZ: INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::FrameTranslation, 1);
		break;
./

FRX: DECIMAL;
/. case $rule_number: ./
FRY: DECIMAL;
/. case $rule_number: ./
FRZ: DECIMAL;
/. case $rule_number: ./
_FRX: INTEGER;
/. case $rule_number: ./
_FRY: INTEGER;
/. case $rule_number: ./
_FRZ: INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::FrameRotation, 1);
		break;
./

FSCL: DECIMAL;
/. case $rule_number: ./
_FSCL: INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::PointType, 1);
		break;
./

---- Points List

POINTNAME: WORD
/. case $rule_number: ./
	| INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::PointName, 1);
		if (!_lexerMode)
		{
			_curPoint = &_curFrame->addPoint();
			_curPoint->name = toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		}
		if (!_contexts.empty() && _contexts.back() == CooLexerIO::OUT1MODE)
			_inlineContexts.insert(CooLexerIO::OUT1MODE);
		gotPointName(sym(1));
		break;
./

PXCOORD: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.x = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;
./
PYCOORD: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.y = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;
./
PZCOORD: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		if (!_lexerMode)
			_curPoint->position.z = sym(1).toDouble();
		gotPointCoordinate(sym(1));
		break;
./
PNCOORD: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoordinate, 1);
		break;
./

PXSIGMA: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmax = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;
./
PYSIGMA: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmay = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;
./
PZSIGMA: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointSigma, 1);
		if (!_lexerMode)
			_curPoint->position.sigmaz = sym(1).toDouble();
		gotPointSigma(sym(1));
		break;
./

PXDISPL: Number;
/. case $rule_number: ./
PYDISPL: Number;
/. case $rule_number: ./
PZDISPL: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointDisplacement, 1);
		gotPointDisplacement(sym(1));
		break;
./

PID: INTEGER
/. case $rule_number: ./
	| WORD;
/.
	case $rule_number:
		addStyleSym(Styles::PointInfo, 1);
		if (!_lexerMode)
			_curPoint->extraInfos.addExtraInfo("id", toByteArray(toTrimmedQString(sym(1)), utf8()).constData());
		gotPointInfo(sym(1));
		break;
./
PDCUM: Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointInfo, 1);
		if (!_lexerMode)
			_curPoint->extraInfos.addExtraInfo("DCUM", toByteArray(toTrimmedQString(sym(1)), utf8()).constData());
		gotPointInfo(sym(1));
		break;
./

POPTION: WORD;
/.
	case $rule_number:
	{
		QStringRef type = sym(1).trimmed();
		if (type == "CALA")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = false;
			}
		}
		else if (type == "POIN" || type == "VXYZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VXY")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = false;
			}
		}
		else if (type == "VXZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = true;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VYZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = true;
				_curPoint->position.isfreez = true;
			}
		}
		else if (type == "VZ")
		{
			addStyleSym(Styles::PointType, 1);
			if (!_lexerMode)
			{
				_curPoint->position.isfreex = false;
				_curPoint->position.isfreey = false;
				_curPoint->position.isfreez = true;
			}
		}
		gotPointType(sym(1));
		break;
	}
./

---- Global

CooDocument: CooPoints
	| CooPoints CooFrames;

---- CooPoints

CooPoints: CooHeader CooContents;

---- CooHeader

CooHeader: CooComments
	| CooComments CooRubbish EOL;

CooComments: CooComment EOL
	| CooComments CooComment EOL;
CooComment: CReferential
	| COMMENTSTRING
/. case $rule_number: ./
	| PERCENTAGE
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
	| PERCENTAGE CooRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./

---- CooContents

CooContents: CooContentsPUNC
	| CooContentsHZ
	| CooContentsHN
	| CooContentsZHN
	| CooContentsOUT1
	| CooContentsOther;

	-- CooContentsPUNC

CooContentsPUNC: CooContentsPUNCHeader CooContentsPUNCPoints
	| CooContentsPUNCHeader CooContentsPUNCPoints CooContentsPUNCHtol CooContentsPUNCHtolPoints;

CooContentsPUNCHeader: CooContentsPUNCHeaderColumns EOL Hunits EOL;
CooContentsPUNCHeaderColumns: Hnom Hx Hy Hz
	| Hnom Hx Hy Hh;

CooContentsPUNCPoints: CooContentsPUNCPoint EOL
	| CooContentsPUNCPoints CooContentsPUNCPoint EOL;
CooContentsPUNCPoint: POINTNAME PXCOORD PYCOORD PZCOORD
	| POINTNAME;

CooContentsPUNCHtol: Htol EOL CooRubbish EOL;
CooContentsPUNCHtolPoints: CooContentsPUNCHtolPoint EOL
	| CooContentsPUNCHtolPoints CooContentsPUNCHtolPoint EOL;
CooContentsPUNCHtolPoint:  POINTNAME PXCOORD PYCOORD PZCOORD PXDISPL PYDISPL PZDISPL POPTION;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 8);
		break;
./

	-- CooContentsHZ

CooContentsHZ: CooContentsHZHeader CooContentsHZPoints;

CooContentsHZHeader: CooContentsHZHeaderColumns EOL Hunits EOL;
CooContentsHZHeaderColumns: Hnom Hx Hy Hz Hh;

CooContentsHZPoints: CooContentsHZPoint EOL
	| CooContentsHZPoints CooContentsHZPoint EOL;
CooContentsHZPoint: POINTNAME PXCOORD PYCOORD PZCOORD PZCOORD;

	-- CooContentsHN

CooContentsHN: CooContentsHNHeader CooContentsHNPoints;

CooContentsHNHeader: CooContentsHNHeaderColumns EOL Hunits EOL;
CooContentsHNHeaderColumns: Hnom Hx Hy Hh Hn;

CooContentsHNPoints: CooContentsHNPoint EOL
	| CooContentsHNPoints CooContentsHNPoint EOL;
CooContentsHNPoint: POINTNAME PXCOORD PYCOORD PZCOORD PNCOORD;

	-- CooContentsZHN

CooContentsZHN: CooContentsZHNHeader CooContentsZHNPoints;

CooContentsZHNHeader: CooContentsZHNHeaderColumns EOL Hunits EOL;
CooContentsZHNHeaderColumns: Hnom Hx Hy Hz Hh Hn;

CooContentsZHNPoints: CooContentsZHNPoint EOL
	| CooContentsZHNPoints CooContentsZHNPoint EOL;
CooContentsZHNPoint: POINTNAME PXCOORD PYCOORD PZCOORD PZCOORD PNCOORD;

	-- CooContentsOUT1

CooContentsOUT1: CooContentsOUT1Header CooContentsOUT1Points;

CooContentsOUT1Header: CooContentsOUT1HeaderColumns EOL Hunits EOL;
/.
	case $rule_number:
		_contexts.push_back(CooLexerIO::OUT1MODE);
		break;
./
CooContentsOUT1HeaderColumns: Hnom Hx Hy Hz Hid Hdx Hdy Hdz Hdcum Hoption
	| Hnom Hx Hy Hh Hid Hdx Hdy Hdz Hdcum Hoption
	| Hnom Hx Hy Hz Hid Hdx Hdy Hdh Hdcum Hoption
	| Hnom Hx Hy Hh Hid Hdx Hdy Hdh Hdcum Hoption;

CooContentsOUT1Points: CooContentsOUT1Point EOL
	| CooContentsOUT1Points CooContentsOUT1Point EOL;
CooContentsOUT1Point: POINTNAME PXCOORD PYCOORD PZCOORD PID PXDISPL PYDISPL PZDISPL PDCUM POPTION
	| POINTNAME PXCOORD PYCOORD PZCOORD PID PXDISPL PYDISPL PZDISPL PDCUM POPTION Hsx PXSIGMA Hsy PYSIGMA Hsz PZSIGMA
	| POINTNAME PXCOORD PYCOORD PZCOORD PID PDCUM POPTION
	| POINTNAME ID PXCOORD PYCOORD PZCOORD DCUM POPTION;

	-- CooContentsOther

CooContentsOther: CooContentsOtherHeader CooContentsOtherPoints;

CooContentsOtherHeader: CooContentsOtherHeaderColumns EOL Hunits EOL;
CooContentsOtherHeaderColumns: Hnom Hx Hy Hz Hsx Hsy Hsz Hcovxy Hcovxz Hcovyz Hdx Hdy Hdz -- PUNC E
	| Hnom Hx Hy Hz Hdirectionx Hdirectiony Hdirectionz Hlongueurx Hlongueury Hlongueurz Hdx Hdy Hdz -- PUNC EE
	| Hnom Hx Hy Hz Hsx Hsy Hsz; -- PUNC T

CooContentsOtherPoints: CooContentsOtherPoint EOL
	| CooContentsOtherPoints CooContentsOtherPoint EOL;
CooContentsOtherPoint: POINTNAME PXCOORD PYCOORD PZCOORD
	| POINTNAME PXCOORD PYCOORD PZCOORD CooRubbish;

-- CooFrames

CooFrames: CooHeader CooFramesHeader CooFramesList;

CooFramesHeader: Frame FrameId Tx Ty Tz Rx Ry Rz Scl _Tx _Ty _Tz _Rx _Ry _Rz _Scl EOL Hunits EOL;

CooFramesList: CooFrame CooFramesList
	| CooFrame;

CooFrame: FRAMENAME FRAMEID FTX FTY FTZ FRX FRY FRZ FSCL _FTX _FTY _FTZ _FRX _FRY _FRZ _FSCL EOL;


----------------------------------------------------------- ENDRULES

/.
	} // of the switch
}

int CooLexerIO::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();
	if (tval.isEmpty())
		return CooLexerIO::WORD;

	// comment
	if (commentChars().contains(tval[0]))
	{
		if (tval == CooLexerIO::spell[CooLexerIO::OLOC])
			return CooLexerIO::OLOC;
		if (tval == CooLexerIO::spell[CooLexerIO::LEP])
			return CooLexerIO::LEP;
		if (tval == CooLexerIO::spell[CooLexerIO::RS2K])
			return CooLexerIO::RS2K;
		if (tval == CooLexerIO::spell[CooLexerIO::SPHE])
			return CooLexerIO::SPHE;
		return CooLexerIO::COMMENTSTRING;
	}
	// numbers
	if (tval == "NA" || tval == "nan" || tval == "NAN")
		return CooLexerIO::DECIMAL;
	if (numericrgx.match(tval).hasMatch())
	{
		bool ok;
		tval.toInt(&ok);
		if (ok)
			return CooLexerIO::INTEGER;
		tval.toDouble(&ok);
		if (ok)
			return CooLexerIO::DECIMAL;
	}
	// keywords
	if (value.position() == _currentLine.position() && _currentLine.trimmed().startsWith(CooLexerIO::spell[CooLexerIO::HTOL]))
		return CooLexerIO::HTOL;
	if (_contexts.empty() && value.position() == _currentLine.position() && tval == CooLexerIO::spell[CooLexerIO::NOM])
	{
		_inlineContexts.insert(CooLexerIO::COLUMNDEF);
		return CooLexerIO::NOM;
	}
	if (value.position() == _currentLine.position() && tval == CooLexerIO::spell[CooLexerIO::FRAME_NAME])
	{
		_inlineContexts.insert(CooLexerIO::COLUMNDEF);
		return CooLexerIO::FRAME_NAME;
	}
	if (!_inlineContexts.empty())
	{
		for (int i = CooLexerIO::NOM; i < CooLexerIO::TERMINAL_COUNT; i++)
		{
			if (tval.startsWith(CooLexerIO::spell[i]))
				return i;
		}
	}

	// percentage
	if (tval[0] == '%')
		return CooLexerIO::PERCENTAGE; 

	return CooLexerIO::WORD;
}
./
